#include <stdio.h>

int fib( int n )
{
    return n <= 1 ? n : fib( n - 1 ) + fib( n - 2 );
}

void fibptr( int* dst, int n )
{
    int a, b;
    if( n <= 1 ) {
        *dst = n;
        return;
    }
    fibptr( &a, n - 1 );
    fibptr( &b, n - 2 );
    *dst = a + b;
}

int main()
{
    for( int i = 0; i < 10; i++ ) {
        int a;
        fibptr( &a, i );
        printf("%d %d\n", fib( i ), a );
    }
}
